#!/usr/bin/env python

# This is the convusb program, inputs hex character stream (like what's
# dumped by Kai Wang's krepdump.ko kernel module, which has a 4 place hex
# address field, then a single space, then groups of 2 digit bytes) and
# puts out parsed HID code, followed by the hex bytes that drove that line.
# Flag=  -f argument, which changes the input from stdin to whatever comes after
# the -f option 
#
# Thanks go to both Kai Wang and Markus Brueffer, two denizens of the FreeBSD-USB
# mailing list who went WAY out of their way to be of help to me in learning
# what I think is the worst spec I have ever bumped up against.
# Chuck Robey (chuckr@chuckr.org).
# Get the latest version at http://people.freebsd.org/~chuckr/code/python/convusb.py-1.0

import sys, os, os.path, getopt, socket, Tkinter, copy
import parse, tables, items, nogui, TKgui


def usage():
    print "%s: parses input hex lines with leading 4 hex digit address fields" % sys.argv[0]
    print "address fields.  Start with 4 hexdigits, a space, then 16 repetitions of two"
    print "hexdigit byte fields, space delimited.  Flags:"
    print "-g: Output via a GUI"
    print "-h: print usage data and exit"
    print "-f <filename>: if given, switches input from default stdin to the filename"
    print "			given, IF that file exists, else print error and exit."
    print "Input was designed to match the output of Kai Wang's krepdump kernel module's"
    print "output, but if your input is binary, use the Unix \"od -t XC\" utility."



if __name__ == '__main__':

    inputFileFlag = False # -f
    useGUI = False;
    parsedDataStore = {}

    o, a = getopt.getopt(sys.argv[1:], 'hgf:')
    opts = {}
    for k,v in o:
        opts[k] = v
    if  opts.has_key('-h'):
        usage(); sys.exit(0)
    if  opts.has_key('-g'):
        useGUI = True;
    if opts.has_key('-f'):
        inputFileFlag = opts['-f']

    # This is the global environment store.  The keys are the top nybble of
    # the global item, and the data is the data from the last invocation of
    # that global item

    if inputFileFlag == False:
        infile = sys.stdin
    else:
        infile = open(inputFileFlag, 'r')

    p = parse.parse(infile)
    i = items.items(p)
    #i.test()
    #print i.itemStore
    #i.test()
    #sys.exit(0)
    #it = p.getItem()
    #while it != []:
    #    print 'Item is %s' % it
    #    it = p.getItem()
    #sys.exit(0)

    if useGUI == True:
        g = TKgui.TKgui(i, p)
    else:
        n = nogui.nogui(i, p)
        n.playRecords()
    sys.exit(0)

